// =================================== CPUʱȭ ͷƮ ===================
//      : CPU  ͷƮ  ƾ
// ----------------------------------------------------------------------------
//   

// Լ 

//  
unsigned char com1_rx_data,com1_rx_eflg = 0;			// COM1(USARTC0)   ͷƮ  /÷
unsigned char com2_rx_data,com2_rx_eflg = 0;			// COM2(USARTD0)   ͷƮ  /÷
unsigned char com3_rx_data,com3_rx_eflg = 0;			// COM3(USARTE0)   ͷƮ  /÷
unsigned char com4_rx_data,com4_rx_eflg = 0;			// COM4(USARTF0)   ͷƮ  /÷
unsigned char com5_rx_data,com5_rx_eflg = 0;			// COM5(USARTC1)   ͷƮ  /÷
unsigned char com6_rx_data,com6_rx_eflg = 0;			// COM6(USARTC1)   ͷƮ  /÷
unsigned char com7_rx_data,com7_rx_eflg = 0;			// COM7(USARTD1)   ͷƮ  /÷
unsigned char com8_rx_data,com8_rx_eflg = 0;			// COM8(USARTE1)   ͷƮ  /÷

int timer0_cnt = 0;						// TCC0 ͷƮ  ī
int timer1_cnt = 0;						// TCC1 ͷƮ  ī
int timer2_cnt = 0;						// TCD0 ͷƮ  ī
int timer3_cnt = 0;						// TCD1 ͷƮ  ī
int timer4_cnt = 0;						// TCE0 ͷƮ  ī
int timer5_cnt = 0;						// TCE1 ͷƮ  ī
int timer6_cnt = 0;						// TCF0 ͷƮ  ī
int timer7_cnt = 0;						// TCF1 ͷƮ  ī

int exint0_flg_0 = 0;						// PORTE_0 Interrupt
int exint0_flg_1 = 0;						// PORTE_1 Interrupt
int exint0_flg_2 = 0;						// PORTE_2 Interrupt
int exint0_flg_3 = 0;						// PORTE_3 Interrupt

// ===================================== CPUʱȭ ============================
// [μ] void
// ----------------------------------------------------------------------------
void cpu_setup(void)
{
unsigned char uch;

#asm("cli")							// ͷƮ 

// system clock setup
	// external oscillator initialization
	OSC.XOSCCTRL = OSC_FRQRANGE_12TO16_gc | OSC_XOSCSEL_XTAL_16KCLK_gc;// XTAL 8MHz, 16K CLK startup time
	OSC.CTRL = OSC_XOSCEN_bm;				// external oscillator enable
	while((OSC.STATUS & OSC_XOSCRDY_bm) == 0);		// external clock source ready

	// PLL initialization
	uch = OSC_PLLSRC_XOSC_gc | 4;				// PLL clock source XTAL, multiplication factor = 4(8MHz*4 = 32MHz)
	CCP = CCP_IOREG_gc;					// write to configuration change protection register(IO register)
	OSC.PLLCTRL = uch;
	OSC.CTRL |= OSC_PLLEN_bm;				// Enable the PLL

	// System clock prescalers A,B,C set
	// clkPer4: 32MHz
	// clkPer2: 32MHz
	// clkPer : 32MHz
	// clkCPU : 32MHz
	uch = CLK_PSADIV_1_gc | CLK_PSBCDIV_1_1_gc;		// prescaler division factor(A=1, B=1, C=1)
	CCP = CCP_IOREG_gc;					// write to configuration change protection register(IO register)
	CLK.PSCTRL = uch;
	while((OSC.STATUS & OSC_PLLRDY_bm) == 0);		// PLL ready

	// select the system clock source
	uch = CLK_SCLKSEL_PLL_gc;				// Select the system clock source: Phase Locked Loop
	CCP=CCP_IOREG_gc;					// write to configuration change protection register(IO register)
	CLK.CTRL = uch;

// portc_7 system clock output
//	PORTCFG.CLKEVOUT = PORTCFG_CLKOUT_PC7_gc;		// poetc_7 bit clock output
//	PORTC.DIRSET |= 0x80;

// USART 
//	Com_Init(&USARTC0, USART_CMODE_ASYNCHRONOUS_gc, 19200L, USART_CHSIZE_8BIT_gc, USART_PMODE_DISABLED_gc, 1);// COM1(PORTC0) ASYNC,19200,8,N,1 
//	Com_Init(&USARTC1, USART_CMODE_ASYNCHRONOUS_gc, 19200L, USART_CHSIZE_8BIT_gc, USART_PMODE_DISABLED_gc, 1);// COM2(PORTC1) ASYNC,19200,8,N,1 
//	Com_Init(&USARTD0, USART_CMODE_ASYNCHRONOUS_gc, 19200L, USART_CHSIZE_8BIT_gc, USART_PMODE_DISABLED_gc, 1);// COM3(PORTD0) ASYNC,19200,8,N,1 
//	Com_Init(&USARTD1, USART_CMODE_ASYNCHRONOUS_gc, 19200L, USART_CHSIZE_8BIT_gc, USART_PMODE_DISABLED_gc, 1);// COM4(PORTD1) ASYNC,19200,8,N,1 
//	Com_Init(&USARTE0, USART_CMODE_ASYNCHRONOUS_gc, 19200L, USART_CHSIZE_8BIT_gc, USART_PMODE_DISABLED_gc, 1);// COM5(PORTE0) ASYNC,19200,8,N,1 
//	Com_Init(&USARTE1, USART_CMODE_ASYNCHRONOUS_gc, 19200L, USART_CHSIZE_8BIT_gc, USART_PMODE_DISABLED_gc, 1);// COM6(PORTE1) ASYNC,19200,8,N,1 
	Com_Init(&USARTF0, USART_CMODE_ASYNCHRONOUS_gc, 19200L, USART_CHSIZE_8BIT_gc, USART_PMODE_DISABLED_gc, 1);// COM7(PORTF0) ASYNC,19200,8,N,1 
	Com_Init(&USARTF1, USART_CMODE_ASYNCHRONOUS_gc, 19200L, USART_CHSIZE_8BIT_gc, USART_PMODE_DISABLED_gc, 1);// COM8(PORTF1) ASYNC,19200,8,N,1 

	PMIC.CTRL |= PMIC_LOLVLEX_bm;				// Enable PMIC interrupt level low.(PMIC_LOLVLEX_bm, PMIC_MEDLVLEX_bm, PMIC_HILVLEX_bm)

#asm("sei")							// ͷƮ 㰡
}

// ============================= PORTE Interrupt0 =============================
// [μ] void
// ----------------------------------------------------------------------------
interrupt [PORTE_INT0_vect] void porte_int0_isr(void)
{
unsigned char datac;

	datac = PORTE.IN & 0x0f;				// PORTE Input[0..3]
	if((datac & 0x01) == 0) exint0_flg_0 = 1;		// PORTE_0 Interrupt
	if((datac & 0x02) == 0) exint0_flg_1 = 1;		// PORTE_1 Interrupt
	if((datac & 0x04) == 0) exint0_flg_2 = 1;		// PORTE_2 Interrupt
	if((datac & 0x08) == 0) exint0_flg_3 = 1;		// PORTE_3 Interrupt
}

// =========================== USARTC0  ͷƮ ==========================
// [μ] void
// ----------------------------------------------------------------------------
interrupt [USARTC0_RXC_vect] void usartc0_rx_isr(void)
{
unsigned char status, data;

	status = USARTC0.STATUS;				//   
	data = USARTC0.DATA;					//   
	if((status & (USART_FERR_bm | USART_PERR_bm | USART_BUFOVF_bm)) == 0){//   ˻ 
		com1_rx_data = data;				//  
		com1_rx_eflg = 1;				//  Ϸ flag set
	}
}

// =========================== USARTC1  ͷƮ ==========================
// [μ] void
// ----------------------------------------------------------------------------
interrupt [USARTC1_RXC_vect] void usartc1_rx_isr(void)
{
unsigned char status, data;

	status = USARTC1.STATUS;				//   
	data = USARTC1.DATA;					//   
	if((status & (USART_FERR_bm | USART_PERR_bm | USART_BUFOVF_bm)) == 0){//   ˻ 
		com2_rx_data = data;				//  
		com2_rx_eflg = 1;				//  Ϸ flag set
	}
}

// =========================== USARTD0  ͷƮ ==========================
// [μ] void
// ----------------------------------------------------------------------------
interrupt [USARTD0_RXC_vect] void usartd0_rx_isr(void)
{
unsigned char status, data;

	status = USARTD0.STATUS;				//   
	data = USARTD0.DATA;					//   
	if((status & (USART_FERR_bm | USART_PERR_bm | USART_BUFOVF_bm)) == 0){//   ˻ 
		com3_rx_data = data;				//  
		com3_rx_eflg = 1;				//  Ϸ flag set
	}
}

// =========================== USARTD1  ͷƮ ==========================
// [μ] void
// ----------------------------------------------------------------------------
interrupt [USARTD1_RXC_vect] void usartd1_rx_isr(void)
{
unsigned char status, data;

	status = USARTD1.STATUS;				//   
	data = USARTD1.DATA;					//   
	if((status & (USART_FERR_bm | USART_PERR_bm | USART_BUFOVF_bm)) == 0){//   ˻ 
		com4_rx_data = data;				//  
		com4_rx_eflg = 1;				//  Ϸ flag set
	}
}

// =========================== USARTE0  ͷƮ ==========================
// [μ] void
// ----------------------------------------------------------------------------
interrupt [USARTE0_RXC_vect] void usarte0_rx_isr(void)
{
unsigned char status, data;

	status = USARTE0.STATUS;				//   
	data = USARTE0.DATA;					//   
	if((status & (USART_FERR_bm | USART_PERR_bm | USART_BUFOVF_bm)) == 0){//   ˻ 
		com5_rx_data = data;				//  
		com5_rx_eflg = 1;				//  Ϸ flag set
	}
}

// =========================== USARTE1  ͷƮ ==========================
// [μ] void
// ----------------------------------------------------------------------------
interrupt [USARTE1_RXC_vect] void usarte1_rx_isr(void)
{
unsigned char status, data;

	status = USARTE1.STATUS;				//   
	data = USARTE1.DATA;					//   
	if((status & (USART_FERR_bm | USART_PERR_bm | USART_BUFOVF_bm)) == 0){//   ˻ 
		com6_rx_data = data;				//  
		com6_rx_eflg = 1;				//  Ϸ flag set
	}
}

// =========================== USARTF0  ͷƮ ==========================
// [μ] void
// ----------------------------------------------------------------------------
interrupt [USARTF0_RXC_vect] void usartf0_rx_isr(void)
{
unsigned char status, data;

	status = USARTF0.STATUS;				//   
	data = USARTF0.DATA;					//   
	if((status & (USART_FERR_bm | USART_PERR_bm | USART_BUFOVF_bm)) == 0){//   ˻ 
		com7_rx_data = data;				//  
		com7_rx_eflg = 1;				//  Ϸ flag set
	}
}

// =========================== USARTF1  ͷƮ ==========================
// [μ] void
// ----------------------------------------------------------------------------
interrupt [USARTF1_RXC_vect] void usartf1_rx_isr(void)
{
unsigned char status, data;

	status = USARTF1.STATUS;				//   
	data = USARTF1.DATA;					//   
	if((status & (USART_FERR_bm | USART_PERR_bm | USART_BUFOVF_bm)) == 0){//   ˻ 
		com8_rx_data = data;				//  
		com8_rx_eflg = 1;				//  Ϸ flag set
	}
}

// ============================ TCC0 overflow ͷƮ ========================
// [μ] void
// [] 32,000,000Hz / 256 / 1250 =  1 / 100.0 = 10.0ms
// ----------------------------------------------------------------------------
interrupt [TCC0_OVF_vect] void tcc0_overflow_isr(void)
{
	TCC0.CNT = 64285;					// 65535-1250 = 64285
	timer0_cnt++;						// Ÿ̸0 ī
}

// ============================ TCC1 overflow ͷƮ ========================
// [μ] void
// [] 32,000,000Hz / 256 / 1250 =  1 / 100.0 = 10.0ms
// ----------------------------------------------------------------------------
interrupt [TCC1_OVF_vect] void tcc1_overflow_isr(void)
{
	TCC1.CNT = 64285;					// 65535-1250 = 64285
	timer1_cnt++;						// Ÿ̸1 ī
}

// ============================ TCD0 overflow ͷƮ ========================
// [μ] void
// [] 32,000,000Hz / 256 / 1250 =  1 / 100.0 = 10.0ms
// ----------------------------------------------------------------------------
interrupt [TCD0_OVF_vect] void tcd0_overflow_isr(void)
{
	TCD0.CNT = 64285;					// 65535-1250 = 64285
	timer2_cnt++;						// Ÿ̸2 ī
}

// ============================ TCD1 overflow ͷƮ ========================
// [μ] void
// [] 32,000,000Hz / 256 / 1250 =  1 / 100.0 = 10.0ms
// ----------------------------------------------------------------------------
interrupt [TCD1_OVF_vect] void tcd1_overflow_isr(void)
{
	TCD1.CNT = 64285;					// 65535-1250 = 64285
	timer3_cnt++;						// Ÿ̸3 ī
}

// ============================ TCE0 overflow ͷƮ ========================
// [μ] void
// [] 32,000,000Hz / 256 / 1250 =  1 / 100.0 = 10.0ms
// ----------------------------------------------------------------------------
interrupt [TCE0_OVF_vect] void tce0_overflow_isr(void)
{
	TCE0.CNT = 64285;					// 65535-1250 = 64285
	timer4_cnt++;						// Ÿ̸4 ī
}

// ============================ TCE1 overflow ͷƮ ========================
// [μ] void
// [] 32,000,000Hz / 256 / 1250 =  1 / 100.0 = 10.0ms
// ----------------------------------------------------------------------------
interrupt [TCE1_OVF_vect] void tce1_overflow_isr(void)
{
	TCE1.CNT = 64285;					// 65535-1250 = 64285
	timer5_cnt++;						// Ÿ̸5 ī
}

// ============================ TCF0 overflow ͷƮ ========================
// [μ] void
// [] 32,000,000Hz / 256 / 1250 =  1 / 100.0 = 10.0ms
// ----------------------------------------------------------------------------
interrupt [TCF0_OVF_vect] void tcf0_overflow_isr(void)
{
	TCF0.CNT = 64285;					// 65535-1250 = 64285
	timer6_cnt++;						// Ÿ̸6 ī
}

// ============================ TCF1 overflow ͷƮ ========================
// [μ] void
// [] 32,000,000Hz / 256 / 1250 =  1 / 100.0 = 10.0ms
// ----------------------------------------------------------------------------
interrupt [TCF1_OVF_vect] void tcf1_overflow_isr(void)
{
	TCF1.CNT = 64285;					// 65535-1250 = 64285
	timer7_cnt++;						// Ÿ̸7 ī
}
